package com.example.aped.ui.all_IOs;

import android.app.Activity;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.SearchView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;

import org.json.JSONObject;

import java.util.List;

public class AllIOsFragment extends Fragment {
    private MainActivity mainActivity;
    ListView lv;
    SearchView searchView;
    ArrayAdapter<String> adapter;
    //List<String> name = MainActivity.xml.getDeviceNames();//{"IN1", "Temperatur extern > 5°C", "Strom Heizung < 10A"};
    //String[] state = {"FALSE", "TRUE", "FALSE"};
    int image;// =new int[MainActivity.xml.getDeviceNames().size()];// {R.drawable.red_signal, R.drawable.green_signal, R.drawable.red_signal};
    int favorite_image ;//= new int[MainActivity.xml.getDeviceNames().size()];//{android.R.drawable.btn_star_big_off, android.R.drawable.btn_star_big_on, android.R.drawable.btn_star_big_off};
    //int[] favoriten_state = new int[MainActivity.xml.getDeviceNames().size()];

    @Override
    public View onCreateView(LayoutInflater inflater,
                             ViewGroup container,
                             Bundle savedInstanceState) {
        this.mainActivity = (MainActivity) getActivity();
        View view = inflater.inflate(R.layout.fragment_all_ios, container,
                false);
        lv = (ListView) view.findViewById(R.id.idListView);
        CustomAdapter customAdapter = new CustomAdapter();
        lv.setAdapter(customAdapter);
        return view;
    }

        class CustomAdapter extends BaseAdapter {

            @Override
            public int getCount() {
                return mainActivity.xml.getDeviceNames().size();
            }

            @Override
            public Object getItem(int position) {

                return null;
            }

            @Override
            public long getItemId(int position) {

                return 0;
            }

            @Override
            public View getView(int i, View view, ViewGroup viewGroup) {
                /*if(mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().get(i)).equals("TRUE")) {
                    image=R.drawable.green_signal;
                }else if (mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().get(i)).equals("FALSE")) {
                    image = R.drawable.red_signal;
                }
                else{*/
                    image = R.drawable.off_signal;
                //}
                if (mainActivity.favorite.getFavorites().contains(mainActivity.xml.getDeviceNames().get(i))) {
                    favorite_image = android.R.drawable.btn_star_big_on;
                }else {
                    favorite_image = android.R.drawable.btn_star_big_off;
                }
                view = getLayoutInflater().inflate(R.layout.listview_layout, null);
                ImageView imageView = (ImageView) view.findViewById(R.id.images);
                TextView TextView_Name = (TextView) view.findViewById(R.id.textName);
                TextView TextView_State = (TextView) view.findViewById(R.id.textState);
                ImageView ButtonView_Favoriten = (ImageView) view.findViewById(R.id.imageButtonFavoriten);
                /**
                 * Verarbeitung der Favoriten hinzufügung
                 */
                ButtonView_Favoriten.setOnClickListener(new View.OnClickListener(){
                    @Override
                            public void onClick(View view){
                        if (mainActivity.favorite.getFavorites().contains(mainActivity.xml.getDeviceNames().get(i))) {
                            mainActivity.favorite.removeFavorite(mainActivity.xml.getDeviceNames().get(i));
                            favorite_image = android.R.drawable.btn_star_big_off;
                            ButtonView_Favoriten.setImageResource(favorite_image);
                        }else {
                            mainActivity.favorite.addFavorite(mainActivity.xml.getDeviceNames().get(i));
                            favorite_image = android.R.drawable.btn_star_big_on;
                            ButtonView_Favoriten.setImageResource(favorite_image);
                        }
                    }
                });

                /**
                 * Verarbeitung/ Änderung der Zustände DO
                 */
                imageView.setOnClickListener(new View.OnClickListener(){
                    @Override
                    public void onClick(View view){
                        Toast.makeText(getContext(),"Click auf: "+i, Toast.LENGTH_SHORT).show();
                    }
                });


                imageView.setImageResource(image);
                TextView_Name.setText(mainActivity.xml.getDeviceNames().get(i));
                //TextView_State.setText(mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().get(i)));
                mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().get(i), new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(JSONObject response) {
                        TextView_State.setText(response.toString());
                    }
                });
                ButtonView_Favoriten.setImageResource(favorite_image);
                return view;
            }
        }
    }
